MODEL.SETPERSISTENT.lua.wUmweltZoneWarning = BOOL_MODEL(true) 
MODEL.SETPERSISTENT.lua.wUmweltZoneTTS = BOOL_MODEL(false)
MODEL.SETPERSISTENT.lua.wUmweltSoundName = WSTRING_MODEL(L"")
MODEL.SET.lua.wUmweltZoneHidden = BOOL_MODEL(false)
MODEL.SETPERSISTENT.lua.wAutoRecalc = BOOL_MODEL(true)


wStartPlanningMethod = false
sc_EasyNavInit_PlanningMethod = function() 
	if not wStartPlanningMethod then
		if MODEL.EXISTS.route.allow_env_zone() then
			obs_wumwelt_nonactive:START("NO_TRIGGER")
			obs_wumwelt_active:START("NO_TRIGGER")
		end
		wStartPlanningMethod = true
	end
end

wUmweltSpeakingID = 0
sc_wUmweltZoneActive = function()
	MODEL.lua.wUmweltZoneHidden = false
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian or not (st_EasyNav.isActive or vActiveState() == "st_screensaver") or not (MODEL.navigation.is_in_simulation() or MODEL.gps.connection_status() < 3 and not MODEL.lua.dragMode() and (MODEL.navigation.car_pos_valid() or MODEL.gps.valid() or MODEL.navigation.dead_reckoning())) then
		return
	end
	if MODEL.lua.wUmweltZoneTTS() then
		local text = sc_wGetTextReadOutUnweltZone(MODEL.navigation.env_zone_distance(), MODEL.navigation.env_zone_remaining.valid(), MODEL.navigation.env_zone_remaining_limit_reached(), MODEL.navigation.env_zone_remaining_destination_reached(), MODEL.navigation.env_zone_remaining())
		sc_wPromptCancel("wUmweltSpeakingID") 
		if not (MODEL.sound.speech.is_say_bool() and MODEL.sound.speech.saying_source() == "voice.guidance" or wDASpeakingID or wSpeedCameraSpeakingID or MODEL.sound.os_muted() or MODEL.sound.voice_muted()) then
			wUmweltSpeakingID = MODEL.sound.speech.say("voice.ui", text, {priority = 21, boosted_priority = 25, callback = function(res) if res > 1 then wUmweltSpeakingID = 0 end end})
		end
	else
		MODEL.sound.playchanneltest("alarmeffect", MODEL.lua.wUmweltSoundName())
	end
end
 
sc_wUmweltZoneHide = function()
	MODEL.lua.wUmweltZoneHidden = true
	PLAYSOUND("alarmeffect", "!ding")
	sc_wPromptCancel("wUmweltSpeakingID")
end

sc_wGetTextReadOutUnweltZone = function(dist,rem_valid,rem_limit_reached,rem_dest_reached,rem_dist)
	if dist>0 and not rem_valid then
		return translated_voice_format(m_i18n_voice("After %s"), sc_wVoiceFormat_search_distance(dist)) .. L" " .. translate_voice("Environmental Zone")
	elseif rem_limit_reached then
		return translate_voice("Environmental Zone") .. L", " .. (translated_voice_format(m_i18n_voice("Remaining more than %s"), sc_wVoiceFormat_search_distance(rem_dist)) or L"")
	elseif rem_valid or rem_dest_reached then
		local distance_rem = rem_valid and rem_dist or MODEL.navigation.distance_to_destination()
		return translate_voice("Environmental Zone") .. L", " .. (translated_voice_format(m_i18n_voice("Remaining %s"), sc_wVoiceFormat_search_distance(distance_rem)) or L"")
	end
end
 
sc_wVoiceFormat_search_distance = function(inputdistance)
	local unit_names = {"yards","meters","feet"}
	local voicetable_name = type(VOICE.distances["ttspro_"..unit_names[MODEL.regional.units() + 1]]) == "table" and "ttspro_" or ""
	local dist_table = VOICE.distances[voicetable_name..unit_names[MODEL.regional.units() + 1]]
	local _,_,outputdistance = VOICE.distance_formatter(inputdistance)
	if #dist_table == 0 or inputdistance > dist_table[#dist_table-1] then
		return builtin.format(L"%{distance:3}",outputdistance)
	end
	local ind = sc_wVoiceFormat_search_index(outputdistance,dist_table)
	if outputdistance ~= dist_table[ind] then
		ind = sc_wVoiceFormat_search_index(inputdistance,dist_table)
	end
	return VOICE.decode_string(dist_table[ind + 1], 1)
end

sc_wVoiceFormat_search_index = function(distance, dist_table)
	if distance <= dist_table[1] then
		return 1
	elseif distance >= dist_table[#dist_table-1] then
		return #dist_table-1
	else
		local lo = 1
		local hi = #dist_table >> 1
		local dist, idx
		repeat
			idx = (lo+hi)>>1
			dist = dist_table[idx<<1 - 1]
			if dist < distance then
				lo = idx
			elseif dist > distance then
				hi = idx
			else
				break
			end
		until (hi-lo < 2)
		if (dist < distance) then idx = idx+1 end
		return idx<<1 - 1
	end
end
 
sc_wPromptCancel = function(say_id)
	if _G[say_id] > 0 then
		PromptCancel(_G[say_id])
		_G[say_id] = 0
	end
end

local st_SettingRouteParam_enter_orig = st_SettingRouteParam.enter
st_SettingRouteParam.enter = function()
	st_SettingRouteParam_enter_orig()
	if MODEL.EXISTS.route.allow_env_zone() then
		wEnvZoneParam = MODEL.route["allow_env_zone"]()
	end
end
 
st_SettingRouteParam:removeLayers(localMenuLayers)
st_SettingRouteParam.init = function()
	txtTitle.TEXT = m_i18n("Route Settings")
	if not MODEL.lua.vEasyWizModeOnFirstStart() and not MODEL.lua.truck_UI() and (not MODEL.EXISTS.other.license.activation_manager.activation_done() or not MODEL.network.supported() or not not MODEL.other.license.activation_manager.activation_done()) then
		SettingRouteParamWizFooter:TEXT("Finish")
	else
		SettingRouteParamWizFooter:TEXT("Next")
	end
	MODEL.ui.lst_lmRouteParamsList.current_index = 0
	sc_SetCalcmethodText()
end

 
local st_SettingRouteParam_exit_orig = st_SettingRouteParam.exit
st_SettingRouteParam.exit = function()
	if MODEL.EXISTS.route.allow_env_zone() then
		routeParamsChanged = wEnvZoneParam ~= MODEL.route["allow_env_zone"]()
	end
	st_SettingRouteParam_exit_orig()
end
 
local st_SettingRouteParam_loadparams_orig = st_SettingRouteParam.sc_LoadParams
st_SettingRouteParam.sc_LoadParams = function()
	if MODEL.EXISTS.route.allow_env_zone() then
		MODEL.route["allow_env_zone"] = PERSISTENT.route[MODEL.route.vehicle_type()].allow_env_zone()
	end
	st_SettingRouteParam_loadparams_orig()
end
 
local st_SettingRouteParam_saveparams_orig = st_SettingRouteParam.sc_SaveParams
st_SettingRouteParam.sc_SaveParams = function()
	if MODEL.EXISTS.route.allow_env_zone() then
		PERSISTENT.route[MODEL.route.vehicle_type()].allow_env_zone = MODEL.route["allow_env_zone"]()
	end
	st_SettingRouteParam_saveparams_orig()
end

local sc_ResetAllRouteParams_orig = sc_ResetAllRouteParams
sc_ResetAllRouteParams = function()
	for vehicle = 0, EVehicleType.Last do
		PERSISTENT.route[vehicle].allow_env_zone = false
	end
	MODEL.lua.wAutoRecalc = true
	sc_ResetAllRouteParams_orig()
end

sc_btnSR_UmweltZone_OnRelease = function()
	sc_NextStateAnim(st_wUmweltZoneSettings, "horz_scroll", 1, "")
end
 
createState("st_wUmweltZoneSettings")
st_wUmweltZoneSettings:useLayers(backgroundLayers, "ui_wUmweltZoneSettings")
st_wUmweltZoneSettings.init = function()
	txtTitle.TEXT = m_i18n("Environmental Zone Settings")
end

wTestSpeakingID = 0
sc_wUmweltZoneTTS_play = function()
	local text = (translated_voice_format(m_i18n_voice("After %s"), sc_wVoiceFormat_search_distance(800)) .. translate_voice("Environmental Zone") .. L" ") or L""
	if text == L"" then
		text = translate_voice("Environmental Zone")
	end
	sc_wPromptCancel("wTestSpeakingID")
	if not (MODEL.sound.speech.is_say_bool() and MODEL.sound.speech.saying_source() == "voice.guidance") then
		wTestSpeakingID = MODEL.sound.speech.say("voice.ui", text, {priority = 21, boosted_priority = 25, callback = function(res) if res > 1 then wTestSpeakingID = 0 end end})
	end
end

st_wSearchCountryUmweltSign = function(country)
	local country_icons = {"_GER","_GBR","_NED"}
	local bmp = "_eu"
	for _,v in pairs(country_icons) do
		if v == country then
			bmp = v:lower()
			break
		end
	end
	return "umwelt_zone" .. bmp .. ".bmp#2"
end

st_EasyNav:useLayers("ui_wUmweltZoneWarningLayer")

local st_EasyNav_init_orig = st_EasyNav.init
st_EasyNav.init = function()
	st_EasyNav_init_orig()
	sc_gj_set_autorecalc()	
end

sc_gj_set_autorecalc = function()
	if MODEL.lua.wAutoRecalc() and not (MODEL.navigation.is_in_simulation() or MODEL.lua.simulateIsDemo()) then
		MODEL.navigation.autoreplan = true
		MODEL.route.list.navigated.waypoints.autocreate_start = MODEL.navigation.autoreplan()
	else
		if MODEL.navigation.has_route() then
			MODEL.navigation.autoreplan = false
			MODEL.route.list.navigated.waypoints.autocreate_start = MODEL.navigation.autoreplan()
		else
			MODEL.navigation.autoreplan = true
			MODEL.route.list.navigated.waypoints.autocreate_start = MODEL.navigation.autoreplan()
		end
	end
end

sc_SetRouteTypesTable_orig = sc_SetRouteTypesTable
sc_SetRouteTypesTable = function()
  local tmp = false
  if MODEL.lua.green_routing_enabled() then
    if MODEL.lua.vehicleIsGreen() then
      for cntr = 1, #RouteTypes do
        if RouteTypes[cntr].name == "Economical" then
          table.remove(RouteTypes, cntr)
        else
        end
      end
    else
      for cntr = 1, #RouteTypes do
        if RouteTypes[cntr].name == "Economical" then
          tmp = true
          break
        end
      end
      if not tmp then
        table.insert(RouteTypes, 2, {name = "Economical", setting = L"ECO"})
      end
    end
    if MODEL.lua.showGreenUI() then
      tmp = false
      for cntr = 1, #RouteTypes do
        if RouteTypes[cntr].name == "Green" then
          tmp = true
          break
        end
      end
      if not tmp then
        table.insert(RouteTypes, 2, {name = "Green", setting = L"GREEN"})
      end
    else
      for cntr = 1, #RouteTypes do
        if RouteTypes[cntr].name == "Green" then
          table.remove(RouteTypes, cntr)
          break
        end
      end
    end
  end
  sc_SetRouteTypesTableScenic()
  sc_SetRouteTypesTableScenic2()
end

sc_SetRouteTypesTableScenic = function()
	local tmp = false
	for cntr = 1, #RouteTypes do
		if RouteTypes[cntr].setting == L"SCENIC" then
			tmp = true
			break
		end
	end
	if not tmp then
		table.insert(RouteTypes, 5, {name = "Scenic", setting = L"SCENIC"})
	end
	sc_SetCalcmethodText()
end

sc_SetRouteTypesTableScenic2 = function()
	local tmp = false
	for cntr = 1, #RouteTypes do
		if RouteTypes[cntr].setting == L"LEAST_FREEWAYS" then
			tmp = true
			break
		end
	end
	if not tmp then
		table.insert(RouteTypes, 6, {name = "Less Freeways", setting = L"LEAST_FREEWAYS"})
	end
	sc_SetCalcmethodText()
end

---UserSounds

rpmUserSoundType = ""
createState("st_rpmUserSounds")
st_rpmUserSounds:useLayers(backgroundLayers, ui_List_Background, ui_rpmUserSounds)
st_rpmUserSounds.init = function()
	txtTitle.TEXT = m_i18n("Select sound")
end

sc_rpmUserSoundsOnRelease = function()
	local name = MODEL["*"].name()
	if rpmUserSoundType == "Umwelt_zone" then
		MODEL.lua.wUmweltSoundName = name
	end
	sc_back()
	MODEL.sound.playchanneltest("alarmeffect", name)
end 

sc_rpmUserSoundsPlay_OnRelease = function()
	MODEL.sound.playchanneltest("alarmeffect", MODEL["*"].name())
end
 
sc_rpmUserSoundsDel_OnRelease = function()
	local text = translated_format(m_i18n("Remove the sound from the list?"))
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line_wstr(1, text)
	MODEL.screen.msgbox.new.set_line_wstr(2, MODEL["*"].name())
	MODEL.screen.msgbox.new.setup_button(1, "sc_rpmUserSoundsDel_OnRelease_OK", m_i18n("Delete"), "", "ico_del_sml.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_rpmUserSoundsDel_OnRelease_OK = function()
	MODEL.ui.rpmUserSoundList.remove(MODEL.ui.rpmUserSoundList.list.index())
	MODEL.ui.rpmUserSoundList.save()
end
 
sc_rpmUserSoundsAll_OnRelease = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Remove all of the sounds from the list?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_rpmUserSoundsAll_OnRelease_OK", m_i18n("Delete All"), "", "ico_DeleteAll_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_rpmUserSoundsAll_OnRelease_OK = function()
	MODEL.ui.rpmUserSoundList.clear()
	MODEL.ui.rpmUserSoundList.save()
end
 
sc_RescanrpmUserSounds_OnRelease = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Previously found sounds will be removed from the list. Start a new search?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_RescanrpmUserSounds_OnReleaseOK", m_i18n("Find Sound"), "", "ico_Done_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_RescanrpmUserSounds_OnReleaseOK = function()
	ui_rpmSoundScanning:SHOW()
	local oasisFiles = MODEL.oasis.files()
	oasisFiles.useful_dirs_only = true
	oasisFiles.selectable_dir = true
	oasisFiles.unroll_dirs = true
	oasisFiles.path = L"%app%/ui_igo9/audio"
	oasisFiles.filter = L"fcategory:5"
	oasisFiles.create_file_props = false
	oasisFiles.initialize_data()
	if oasisFiles.finished() then
		sc_RescanrpmUserSounds_done()
	else
		obs_Files_rpmSoundScan_Finished:START("NO_TRIGGER")
	end
end
 
sc_RescanrpmUserSounds_done = function()
	obs_Files_rpmSoundScan_Finished:STOP()
	ui_rpmSoundScanning:HIDE()
	MODEL.ui.rpmUserSoundList.clear()
	ui.rpmUserSoundList:add({name=L""})
	local filename, fpath = L"", L""
	for i = 0, MODEL.oasis.files.list.size() - 1 do
		filename = MODEL.oasis.files.list[i].fname():lower()
		fpath = MODEL.oasis.files.list[i].fpath():lower()
		fpath = wstring.sub(fpath, 15, #fpath)
		if fpath == filename then
			ui.rpmUserSoundList:add({name=wstring.gsub(filename, L".wav", L"")})
		end
	end
	MODEL.oasis.files.deinitialize_data()
	MODEL.oasis.files.unroll_dirs = false
	MODEL.ui.rpmUserSoundList.save()
end
 
sc_RescanrpmUserSounds_stop = function()
	obs_Files_rpmSoundScan_Finished:STOP()
	MODEL.oasis.files.deinitialize_data()
	MODEL.oasis.files.unroll_dirs = false
	ui_rpmSoundScanning:HIDE()
end

